package com.sun.rowset;

import java.io.ObjectInputStream;
import javax.sql.rowset.spi.SyncProvider;
import javax.sql.rowset.spi.SyncProviderException;
import javax.sql.RowSetListener;
import java.io.OutputStream;
import java.io.Writer;
import java.net.URL;
import java.sql.Connection;
import java.sql.ResultSet;
import javax.sql.RowSetMetaData;
import java.util.Calendar;
import java.sql.Array;
import java.sql.Clob;
import java.sql.Blob;
import java.sql.Ref;
import java.sql.Statement;
import java.io.Reader;
import java.util.Map;
import java.sql.ResultSetMetaData;
import java.sql.SQLWarning;
import java.io.InputStream;
import java.sql.Timestamp;
import java.sql.Time;
import java.sql.Date;
import java.math.BigDecimal;
import javax.sql.rowset.RowSetMetaDataImpl;
import javax.sql.rowset.CachedRowSet;
import java.util.Collection;
import java.util.ArrayList;
import javax.sql.RowSet;
import javax.sql.rowset.Joinable;
import java.sql.SQLException;
import java.io.IOException;
import javax.sql.rowset.WebRowSet;
import java.util.Vector;
import javax.sql.rowset.JoinRowSet;

public class JoinRowSetImpl extends WebRowSetImpl implements JoinRowSet
{
    private Vector<CachedRowSetImpl> vecRowSetsInJOIN;
    private CachedRowSetImpl crsInternal;
    private Vector<Integer> vecJoinType;
    private Vector<String> vecTableNames;
    private int iMatchKey;
    private String strMatchKey;
    boolean[] supportedJOINs;
    private WebRowSet wrs;
    static final long serialVersionUID = -5590501621560008453L;
    
    public JoinRowSetImpl() throws SQLException {
        this.vecRowSetsInJOIN = new Vector();
        this.crsInternal = new CachedRowSetImpl();
        this.vecJoinType = new Vector();
        this.vecTableNames = new Vector();
        this.iMatchKey = -1;
        this.strMatchKey = null;
        this.supportedJOINs = new boolean[] { false, true, false, false, false };
        try {
            this.resBundle = JdbcRowSetResourceBundle.getJdbcRowSetResourceBundle();
        }
        catch (IOException cause) {
            throw new RuntimeException(cause);
        }
    }
    
    @Override
    public void addRowSet(Joinable joinable) throws SQLException {
        boolean n = false;
        boolean n2 = false;
        if (!(joinable instanceof RowSet)) {
            throw new SQLException(this.resBundle.handleGetObject("joinrowsetimpl.notinstance").toString());
        }
        CachedRowSetImpl cachedRowSetImpl;
        if ((joinable instanceof JdbcRowSetImpl)) {
            cachedRowSetImpl = new CachedRowSetImpl();
            cachedRowSetImpl.populate((RowSet)joinable);
            if (cachedRowSetImpl.size() == 0) {
                throw new SQLException(this.resBundle.handleGetObject("joinrowsetimpl.emptyrowset").toString());
            }
            try {
                int n3 = 0;
                for (int n4 = 0; n4 < joinable.getMatchColumnIndexes().length && joinable.getMatchColumnIndexes()[n4] != -1; ++n4) {
                    ++n3;
                }
                int[] matchColumn = new int[n3];
                for (int i = 0; i < n3; ++i) {
                    matchColumn[i] = joinable.getMatchColumnIndexes()[i];
                }
                cachedRowSetImpl.setMatchColumn(matchColumn);
            }
            catch (SQLException ex) {}
        }
        else {
            cachedRowSetImpl = (CachedRowSetImpl)joinable;
            if (cachedRowSetImpl.size() == 0) {
                throw new SQLException(this.resBundle.handleGetObject("joinrowsetimpl.emptyrowset").toString());
            }
        }
        try {
            this.iMatchKey = cachedRowSetImpl.getMatchColumnIndexes()[0];
        }
        catch (SQLException ex2) {
            n = true;
        }
        try {
            this.strMatchKey = cachedRowSetImpl.getMatchColumnNames()[0];
        }
        catch (SQLException ex3) {
            n2 = true;
        }
        if (n && n2) {
            throw new SQLException(this.resBundle.handleGetObject("joinrowsetimpl.matchnotset").toString());
        }
        if (!(n == 0)) {
            ArrayList o = new ArrayList();
            for (int n5 = 0; n5 < cachedRowSetImpl.getMatchColumnNames().length && (this.strMatchKey = cachedRowSetImpl.getMatchColumnNames()[n5]) != null; ++n5) {
                this.iMatchKey = cachedRowSetImpl.findColumn(this.strMatchKey);
                o.add(Integer.valueOf(this.iMatchKey));
            }
            int[] matchColumn2 = new int[o.size()];
            for (int j = 0; j < o.size(); ++j) {
                matchColumn2[j] = (int)o.get(j);
            }
            cachedRowSetImpl.setMatchColumn(matchColumn2);
        }
        this.initJOIN(cachedRowSetImpl);
        return;
    }
    
    @Override
    public void addRowSet(RowSet set, int matchColumn) throws SQLException {
        ((CachedRowSetImpl)set).setMatchColumn(matchColumn);
        this.addRowSet((Joinable)set);
    }
    
    @Override
    public void addRowSet(RowSet set, String matchColumn) throws SQLException {
        ((CachedRowSetImpl)set).setMatchColumn(matchColumn);
        this.addRowSet((Joinable)set);
    }
    
    @Override
    public void addRowSet(RowSet[] array, int[] array2) throws SQLException {
        if (array.length != array2.length) {
            throw new SQLException(this.resBundle.handleGetObject("joinrowsetimpl.numnotequal").toString());
        }
        for (int i = 0; i < array.length; ++i) {
            ((CachedRowSetImpl)array[i]).setMatchColumn(array2[i]);
            this.addRowSet((Joinable)array[i]);
        }
        return;
    }
    
    @Override
    public void addRowSet(RowSet[] array, String[] array2) throws SQLException {
        if (array.length != array2.length) {
            throw new SQLException(this.resBundle.handleGetObject("joinrowsetimpl.numnotequal").toString());
        }
        for (int i = 0; i < array.length; ++i) {
            ((CachedRowSetImpl)array[i]).setMatchColumn(array2[i]);
            this.addRowSet((Joinable)array[i]);
        }
        return;
    }
    
    @Override
    public Collection getRowSets() throws SQLException {
        return this.vecRowSetsInJOIN;
    }
    
    @Override
    public String[] getRowSetNames() throws SQLException {
        Object[] array = this.vecTableNames.toArray();
        String[] array2 = new String[array.length];
        for (int i = 0; i < array.length; ++i) {
            array2[i] = array[i].toString();
        }
        return array2;
    }
    
    @Override
    public CachedRowSet toCachedRowSet() throws SQLException {
        return this.crsInternal;
    }
    
    @Override
    public boolean supportsCrossJoin() {
        return this.supportedJOINs[0];
    }
    
    @Override
    public boolean supportsInnerJoin() {
        return this.supportedJOINs[1];
    }
    
    @Override
    public boolean supportsLeftOuterJoin() {
        return this.supportedJOINs[2];
    }
    
    @Override
    public boolean supportsRightOuterJoin() {
        return this.supportedJOINs[3];
    }
    
    @Override
    public boolean supportsFullJoin() {
        return this.supportedJOINs[4];
    }
    
    @Override
    public void setJoinType(int n) throws SQLException {
        if (n >= 0 && n <= 4) {
            if (n != 1) {
                throw new SQLException(this.resBundle.handleGetObject("joinrowsetimpl.notsupported").toString());
            }
            this.vecJoinType.add(Integer.valueOf(1));
            return;
        }
        else {
            throw new SQLException(this.resBundle.handleGetObject("joinrowsetimpl.notdefined").toString());
        }
    }
    
    private boolean checkforMatchColumn(Joinable joinable) throws SQLException {
        return joinable.getMatchColumnIndexes().length > 0;
    }
    
    private void initJOIN(CachedRowSet set) throws SQLException {
        try {
            CachedRowSetImpl cachedRowSetImpl = (CachedRowSetImpl)set;
            CachedRowSetImpl cachedRowSetImpl2 = new CachedRowSetImpl();
            RowSetMetaDataImpl metaData = new RowSetMetaDataImpl();
            if (this.vecRowSetsInJOIN.isEmpty()) {
                (this.crsInternal = (CachedRowSetImpl)set.createCopy()).setMetaData((RowSetMetaDataImpl)cachedRowSetImpl.getMetaData());
                this.vecRowSetsInJOIN.add(cachedRowSetImpl);
            }
            else {
                if (this.vecRowSetsInJOIN.size() - this.vecJoinType.size() == 2) {
                    this.setJoinType(1);
                }
                else if (this.vecRowSetsInJOIN.size() - this.vecJoinType.size() != 1) {}
                this.vecTableNames.add(this.crsInternal.getTableName());
                this.vecTableNames.add(cachedRowSetImpl.getTableName());
                int size = cachedRowSetImpl.size();
                int size2 = this.crsInternal.size();
                int n = 0;
                for (int n2 = 0; n2 < this.crsInternal.getMatchColumnIndexes().length && this.crsInternal.getMatchColumnIndexes()[n2] != -1; ++n2) {
                    ++n;
                }
                metaData.setColumnCount(this.crsInternal.getMetaData().getColumnCount() + cachedRowSetImpl.getMetaData().getColumnCount() - n);
                cachedRowSetImpl2.setMetaData(metaData);
                this.crsInternal.beforeFirst();
                cachedRowSetImpl.beforeFirst();
                for (int n3 = 1; n3 <= size2 && !this.crsInternal.isAfterLast(); ++n3) {
                    if (this.crsInternal.next()) {
                        cachedRowSetImpl.beforeFirst();
                        int i = 1;
                        while (i <= size) {
                            if (cachedRowSetImpl.isAfterLast()) {
                                break;
                            }
                            if (cachedRowSetImpl.next()) {
                                boolean n4 = true;
                                int j = 0;
                                while (j < n) {
                                    if (!this.crsInternal.getObject(this.crsInternal.getMatchColumnIndexes()[j]).equals(cachedRowSetImpl.getObject(cachedRowSetImpl.getMatchColumnIndexes()[j]))) {
                                        n4 = false;
                                        break;
                                    }
                                    ++j;
                                }
                                if (!(n4 == 0)) {
                                    int n5 = 0;
                                    cachedRowSetImpl2.moveToInsertRow();
                                    int k;
                                    for (k = 1; k <= this.crsInternal.getMetaData().getColumnCount(); ++k) {
                                        boolean n6 = false;
                                        int l = 0;
                                        while (l < n) {
                                            if (k == this.crsInternal.getMatchColumnIndexes()[l]) {
                                                n6 = true;
                                                break;
                                            }
                                            ++l;
                                        }
                                        if (n6 == 0) {
                                            cachedRowSetImpl2.updateObject(++n5, this.crsInternal.getObject(k));
                                            metaData.setColumnName(n5, this.crsInternal.getMetaData().getColumnName(k));
                                            metaData.setTableName(n5, this.crsInternal.getTableName());
                                            metaData.setColumnType(k, this.crsInternal.getMetaData().getColumnType(k));
                                            metaData.setAutoIncrement(k, this.crsInternal.getMetaData().isAutoIncrement(k));
                                            metaData.setCaseSensitive(k, this.crsInternal.getMetaData().isCaseSensitive(k));
                                            metaData.setCatalogName(k, this.crsInternal.getMetaData().getCatalogName(k));
                                            metaData.setColumnDisplaySize(k, this.crsInternal.getMetaData().getColumnDisplaySize(k));
                                            metaData.setColumnLabel(k, this.crsInternal.getMetaData().getColumnLabel(k));
                                            metaData.setColumnType(k, this.crsInternal.getMetaData().getColumnType(k));
                                            metaData.setColumnTypeName(k, this.crsInternal.getMetaData().getColumnTypeName(k));
                                            metaData.setCurrency(k, this.crsInternal.getMetaData().isCurrency(k));
                                            metaData.setNullable(k, this.crsInternal.getMetaData().isNullable(k));
                                            metaData.setPrecision(k, this.crsInternal.getMetaData().getPrecision(k));
                                            metaData.setScale(k, this.crsInternal.getMetaData().getScale(k));
                                            metaData.setSchemaName(k, this.crsInternal.getMetaData().getSchemaName(k));
                                            metaData.setSearchable(k, this.crsInternal.getMetaData().isSearchable(k));
                                            metaData.setSigned(k, this.crsInternal.getMetaData().isSigned(k));
                                        }
                                        else {
                                            cachedRowSetImpl2.updateObject(++n5, this.crsInternal.getObject(k));
                                            metaData.setColumnName(n5, this.crsInternal.getMetaData().getColumnName(k));
                                            metaData.setTableName(n5, this.crsInternal.getTableName() + "#" + cachedRowSetImpl.getTableName());
                                            metaData.setColumnType(k, this.crsInternal.getMetaData().getColumnType(k));
                                            metaData.setAutoIncrement(k, this.crsInternal.getMetaData().isAutoIncrement(k));
                                            metaData.setCaseSensitive(k, this.crsInternal.getMetaData().isCaseSensitive(k));
                                            metaData.setCatalogName(k, this.crsInternal.getMetaData().getCatalogName(k));
                                            metaData.setColumnDisplaySize(k, this.crsInternal.getMetaData().getColumnDisplaySize(k));
                                            metaData.setColumnLabel(k, this.crsInternal.getMetaData().getColumnLabel(k));
                                            metaData.setColumnType(k, this.crsInternal.getMetaData().getColumnType(k));
                                            metaData.setColumnTypeName(k, this.crsInternal.getMetaData().getColumnTypeName(k));
                                            metaData.setCurrency(k, this.crsInternal.getMetaData().isCurrency(k));
                                            metaData.setNullable(k, this.crsInternal.getMetaData().isNullable(k));
                                            metaData.setPrecision(k, this.crsInternal.getMetaData().getPrecision(k));
                                            metaData.setScale(k, this.crsInternal.getMetaData().getScale(k));
                                            metaData.setSchemaName(k, this.crsInternal.getMetaData().getSchemaName(k));
                                            metaData.setSearchable(k, this.crsInternal.getMetaData().isSearchable(k));
                                            metaData.setSigned(k, this.crsInternal.getMetaData().isSigned(k));
                                        }
                                    }
                                    for (int n7 = 1; n7 <= cachedRowSetImpl.getMetaData().getColumnCount(); ++n7) {
                                        boolean n8 = false;
                                        int n9 = 0;
                                        while (n9 < n) {
                                            if (n7 == cachedRowSetImpl.getMatchColumnIndexes()[n9]) {
                                                n8 = true;
                                                break;
                                            }
                                            ++n9;
                                        }
                                        if (n8 == 0) {
                                            cachedRowSetImpl2.updateObject(++n5, cachedRowSetImpl.getObject(n7));
                                            metaData.setColumnName(n5, cachedRowSetImpl.getMetaData().getColumnName(n7));
                                            metaData.setTableName(n5, cachedRowSetImpl.getTableName());
                                            metaData.setColumnType(k + n7 - 1, cachedRowSetImpl.getMetaData().getColumnType(n7));
                                            metaData.setAutoIncrement(k + n7 - 1, cachedRowSetImpl.getMetaData().isAutoIncrement(n7));
                                            metaData.setCaseSensitive(k + n7 - 1, cachedRowSetImpl.getMetaData().isCaseSensitive(n7));
                                            metaData.setCatalogName(k + n7 - 1, cachedRowSetImpl.getMetaData().getCatalogName(n7));
                                            metaData.setColumnDisplaySize(k + n7 - 1, cachedRowSetImpl.getMetaData().getColumnDisplaySize(n7));
                                            metaData.setColumnLabel(k + n7 - 1, cachedRowSetImpl.getMetaData().getColumnLabel(n7));
                                            metaData.setColumnType(k + n7 - 1, cachedRowSetImpl.getMetaData().getColumnType(n7));
                                            metaData.setColumnTypeName(k + n7 - 1, cachedRowSetImpl.getMetaData().getColumnTypeName(n7));
                                            metaData.setCurrency(k + n7 - 1, cachedRowSetImpl.getMetaData().isCurrency(n7));
                                            metaData.setNullable(k + n7 - 1, cachedRowSetImpl.getMetaData().isNullable(n7));
                                            metaData.setPrecision(k + n7 - 1, cachedRowSetImpl.getMetaData().getPrecision(n7));
                                            metaData.setScale(k + n7 - 1, cachedRowSetImpl.getMetaData().getScale(n7));
                                            metaData.setSchemaName(k + n7 - 1, cachedRowSetImpl.getMetaData().getSchemaName(n7));
                                            metaData.setSearchable(k + n7 - 1, cachedRowSetImpl.getMetaData().isSearchable(n7));
                                            metaData.setSigned(k + n7 - 1, cachedRowSetImpl.getMetaData().isSigned(n7));
                                        }
                                        else {
                                            --k;
                                        }
                                    }
                                    cachedRowSetImpl2.insertRow();
                                    cachedRowSetImpl2.moveToCurrentRow();
                                }
                            }
                            ++i;
                        }
                    }
                }
                cachedRowSetImpl2.setMetaData(metaData);
                cachedRowSetImpl2.setOriginal();
                int[] matchColumn = new int[n];
                for (int n10 = 0; n10 < n; ++n10) {
                    matchColumn[n10] = this.crsInternal.getMatchColumnIndexes()[n10];
                }
                (this.crsInternal = (CachedRowSetImpl)cachedRowSetImpl2.createCopy()).setMatchColumn(matchColumn);
                this.crsInternal.setMetaData(metaData);
                this.vecRowSetsInJOIN.add(cachedRowSetImpl);
            }
        }
        catch (SQLException obj) {
            obj.printStackTrace();
            throw new SQLException(this.resBundle.handleGetObject("joinrowsetimpl.initerror").toString() + obj);
        }
        catch (Exception obj2) {
            obj2.printStackTrace();
            throw new SQLException(this.resBundle.handleGetObject("joinrowsetimpl.genericerr").toString() + obj2);
        }
    }
    
    @Override
    public String getWhereClause() throws SQLException {
        String concat = "Select ";
        String concat2 = "";
        String concat3 = "";
        int size = this.vecRowSetsInJOIN.size();
        for (int i = 0; i < size; ++i) {
            CachedRowSetImpl cachedRowSetImpl = (CachedRowSetImpl)this.vecRowSetsInJOIN.get(i);
            int columnCount = cachedRowSetImpl.getMetaData().getColumnCount();
            concat2 = concat2.concat(cachedRowSetImpl.getTableName());
            concat3 = concat3.concat(concat2 + ", ");
            for (int j = 1; j < columnCount; concat = concat.concat(concat2 + "." + cachedRowSetImpl.getMetaData().getColumnName(j++)).concat(", ")) {}
        }
        String concat4 = concat.substring(0, concat.lastIndexOf(",")).concat(" from ").concat(concat3);
        String s = concat4.substring(0, concat4.lastIndexOf(",")).concat(" where ");
        String s2;
        for (int k = 0; k < size; s = s2.concat(" "), ++k) {
            String concat5 = s.concat(((CachedRowSetImpl)this.vecRowSetsInJOIN.get(k)).getMatchColumnNames()[0]);
            if (k % 2 != 0) {
                s2 = concat5.concat("=");
            }
            else {
                s2 = concat5.concat(" and");
            }
        }
        return s;
    }
    
    @Override
    public boolean next() throws SQLException {
        return this.crsInternal.next();
    }
    
    @Override
    public void close() throws SQLException {
        this.crsInternal.close();
    }
    
    @Override
    public boolean wasNull() throws SQLException {
        return this.crsInternal.wasNull();
    }
    
    @Override
    public String getString(int n) throws SQLException {
        return this.crsInternal.getString(n);
    }
    
    @Override
    public boolean getBoolean(int n) throws SQLException {
        return this.crsInternal.getBoolean(n);
    }
    
    @Override
    public byte getByte(int n) throws SQLException {
        return this.crsInternal.getByte(n);
    }
    
    @Override
    public short getShort(int n) throws SQLException {
        return this.crsInternal.getShort(n);
    }
    
    @Override
    public int getInt(int n) throws SQLException {
        return this.crsInternal.getInt(n);
    }
    
    @Override
    public long getLong(int n) throws SQLException {
        return this.crsInternal.getLong(n);
    }
    
    @Override
    public float getFloat(int n) throws SQLException {
        return this.crsInternal.getFloat(n);
    }
    
    @Override
    public double getDouble(int n) throws SQLException {
        return this.crsInternal.getDouble(n);
    }
    
    @Deprecated
    @Override
    public BigDecimal getBigDecimal(int n, int n2) throws SQLException {
        return this.crsInternal.getBigDecimal(n);
    }
    
    @Override
    public byte[] getBytes(int n) throws SQLException {
        return this.crsInternal.getBytes(n);
    }
    
    @Override
    public Date getDate(int n) throws SQLException {
        return this.crsInternal.getDate(n);
    }
    
    @Override
    public Time getTime(int n) throws SQLException {
        return this.crsInternal.getTime(n);
    }
    
    @Override
    public Timestamp getTimestamp(int n) throws SQLException {
        return this.crsInternal.getTimestamp(n);
    }
    
    @Override
    public InputStream getAsciiStream(int n) throws SQLException {
        return this.crsInternal.getAsciiStream(n);
    }
    
    @Deprecated
    @Override
    public InputStream getUnicodeStream(int n) throws SQLException {
        return this.crsInternal.getUnicodeStream(n);
    }
    
    @Override
    public InputStream getBinaryStream(int n) throws SQLException {
        return this.crsInternal.getBinaryStream(n);
    }
    
    @Override
    public String getString(String s) throws SQLException {
        return this.crsInternal.getString(s);
    }
    
    @Override
    public boolean getBoolean(String s) throws SQLException {
        return this.crsInternal.getBoolean(s);
    }
    
    @Override
    public byte getByte(String s) throws SQLException {
        return this.crsInternal.getByte(s);
    }
    
    @Override
    public short getShort(String s) throws SQLException {
        return this.crsInternal.getShort(s);
    }
    
    @Override
    public int getInt(String s) throws SQLException {
        return this.crsInternal.getInt(s);
    }
    
    @Override
    public long getLong(String s) throws SQLException {
        return this.crsInternal.getLong(s);
    }
    
    @Override
    public float getFloat(String s) throws SQLException {
        return this.crsInternal.getFloat(s);
    }
    
    @Override
    public double getDouble(String s) throws SQLException {
        return this.crsInternal.getDouble(s);
    }
    
    @Deprecated
    @Override
    public BigDecimal getBigDecimal(String s, int n) throws SQLException {
        return this.crsInternal.getBigDecimal(s);
    }
    
    @Override
    public byte[] getBytes(String s) throws SQLException {
        return this.crsInternal.getBytes(s);
    }
    
    @Override
    public Date getDate(String s) throws SQLException {
        return this.crsInternal.getDate(s);
    }
    
    @Override
    public Time getTime(String s) throws SQLException {
        return this.crsInternal.getTime(s);
    }
    
    @Override
    public Timestamp getTimestamp(String s) throws SQLException {
        return this.crsInternal.getTimestamp(s);
    }
    
    @Override
    public InputStream getAsciiStream(String s) throws SQLException {
        return this.crsInternal.getAsciiStream(s);
    }
    
    @Deprecated
    @Override
    public InputStream getUnicodeStream(String s) throws SQLException {
        return this.crsInternal.getUnicodeStream(s);
    }
    
    @Override
    public InputStream getBinaryStream(String s) throws SQLException {
        return this.crsInternal.getBinaryStream(s);
    }
    
    @Override
    public SQLWarning getWarnings() {
        return this.crsInternal.getWarnings();
    }
    
    @Override
    public void clearWarnings() {
        this.crsInternal.clearWarnings();
    }
    
    @Override
    public String getCursorName() throws SQLException {
        return this.crsInternal.getCursorName();
    }
    
    @Override
    public ResultSetMetaData getMetaData() throws SQLException {
        return this.crsInternal.getMetaData();
    }
    
    @Override
    public Object getObject(int n) throws SQLException {
        return this.crsInternal.getObject(n);
    }
    
    @Override
    public Object getObject(int n, Map<String, Class<?>> map) throws SQLException {
        return this.crsInternal.getObject(n, map);
    }
    
    @Override
    public Object getObject(String s) throws SQLException {
        return this.crsInternal.getObject(s);
    }
    
    @Override
    public Object getObject(String s, Map<String, Class<?>> map) throws SQLException {
        return this.crsInternal.getObject(s, map);
    }
    
    @Override
    public Reader getCharacterStream(int n) throws SQLException {
        return this.crsInternal.getCharacterStream(n);
    }
    
    @Override
    public Reader getCharacterStream(String s) throws SQLException {
        return this.crsInternal.getCharacterStream(s);
    }
    
    @Override
    public BigDecimal getBigDecimal(int n) throws SQLException {
        return this.crsInternal.getBigDecimal(n);
    }
    
    @Override
    public BigDecimal getBigDecimal(String s) throws SQLException {
        return this.crsInternal.getBigDecimal(s);
    }
    
    @Override
    public int size() {
        return this.crsInternal.size();
    }
    
    @Override
    public boolean isBeforeFirst() throws SQLException {
        return this.crsInternal.isBeforeFirst();
    }
    
    @Override
    public boolean isAfterLast() throws SQLException {
        return this.crsInternal.isAfterLast();
    }
    
    @Override
    public boolean isFirst() throws SQLException {
        return this.crsInternal.isFirst();
    }
    
    @Override
    public boolean isLast() throws SQLException {
        return this.crsInternal.isLast();
    }
    
    @Override
    public void beforeFirst() throws SQLException {
        this.crsInternal.beforeFirst();
    }
    
    @Override
    public void afterLast() throws SQLException {
        this.crsInternal.afterLast();
    }
    
    @Override
    public boolean first() throws SQLException {
        return this.crsInternal.first();
    }
    
    @Override
    public boolean last() throws SQLException {
        return this.crsInternal.last();
    }
    
    @Override
    public int getRow() throws SQLException {
        return this.crsInternal.getRow();
    }
    
    @Override
    public boolean absolute(int n) throws SQLException {
        return this.crsInternal.absolute(n);
    }
    
    @Override
    public boolean relative(int n) throws SQLException {
        return this.crsInternal.relative(n);
    }
    
    @Override
    public boolean previous() throws SQLException {
        return this.crsInternal.previous();
    }
    
    @Override
    public int findColumn(String s) throws SQLException {
        return this.crsInternal.findColumn(s);
    }
    
    @Override
    public boolean rowUpdated() throws SQLException {
        return this.crsInternal.rowUpdated();
    }
    
    @Override
    public boolean columnUpdated(int n) throws SQLException {
        return this.crsInternal.columnUpdated(n);
    }
    
    @Override
    public boolean rowInserted() throws SQLException {
        return this.crsInternal.rowInserted();
    }
    
    @Override
    public boolean rowDeleted() throws SQLException {
        return this.crsInternal.rowDeleted();
    }
    
    @Override
    public void updateNull(int n) throws SQLException {
        this.crsInternal.updateNull(n);
    }
    
    @Override
    public void updateBoolean(int n, boolean b) throws SQLException {
        this.crsInternal.updateBoolean(n, b);
    }
    
    @Override
    public void updateByte(int n, byte b) throws SQLException {
        this.crsInternal.updateByte(n, b);
    }
    
    @Override
    public void updateShort(int n, short n2) throws SQLException {
        this.crsInternal.updateShort(n, n2);
    }
    
    @Override
    public void updateInt(int n, int n2) throws SQLException {
        this.crsInternal.updateInt(n, n2);
    }
    
    @Override
    public void updateLong(int n, long n2) throws SQLException {
        this.crsInternal.updateLong(n, n2);
    }
    
    @Override
    public void updateFloat(int n, float n2) throws SQLException {
        this.crsInternal.updateFloat(n, n2);
    }
    
    @Override
    public void updateDouble(int n, double n2) throws SQLException {
        this.crsInternal.updateDouble(n, n2);
    }
    
    @Override
    public void updateBigDecimal(int n, BigDecimal bigDecimal) throws SQLException {
        this.crsInternal.updateBigDecimal(n, bigDecimal);
    }
    
    @Override
    public void updateString(int n, String s) throws SQLException {
        this.crsInternal.updateString(n, s);
    }
    
    @Override
    public void updateBytes(int n, byte[] array) throws SQLException {
        this.crsInternal.updateBytes(n, array);
    }
    
    @Override
    public void updateDate(int n, Date date) throws SQLException {
        this.crsInternal.updateDate(n, date);
    }
    
    @Override
    public void updateTime(int n, Time time) throws SQLException {
        this.crsInternal.updateTime(n, time);
    }
    
    @Override
    public void updateTimestamp(int n, Timestamp timestamp) throws SQLException {
        this.crsInternal.updateTimestamp(n, timestamp);
    }
    
    @Override
    public void updateAsciiStream(int n, InputStream inputStream, int n2) throws SQLException {
        this.crsInternal.updateAsciiStream(n, inputStream, n2);
    }
    
    @Override
    public void updateBinaryStream(int n, InputStream inputStream, int n2) throws SQLException {
        this.crsInternal.updateBinaryStream(n, inputStream, n2);
    }
    
    @Override
    public void updateCharacterStream(int n, Reader reader, int n2) throws SQLException {
        this.crsInternal.updateCharacterStream(n, reader, n2);
    }
    
    @Override
    public void updateObject(int n, Object o, int n2) throws SQLException {
        this.crsInternal.updateObject(n, o, n2);
    }
    
    @Override
    public void updateObject(int n, Object o) throws SQLException {
        this.crsInternal.updateObject(n, o);
    }
    
    @Override
    public void updateNull(String s) throws SQLException {
        this.crsInternal.updateNull(s);
    }
    
    @Override
    public void updateBoolean(String s, boolean b) throws SQLException {
        this.crsInternal.updateBoolean(s, b);
    }
    
    @Override
    public void updateByte(String s, byte b) throws SQLException {
        this.crsInternal.updateByte(s, b);
    }
    
    @Override
    public void updateShort(String s, short n) throws SQLException {
        this.crsInternal.updateShort(s, n);
    }
    
    @Override
    public void updateInt(String s, int n) throws SQLException {
        this.crsInternal.updateInt(s, n);
    }
    
    @Override
    public void updateLong(String s, long n) throws SQLException {
        this.crsInternal.updateLong(s, n);
    }
    
    @Override
    public void updateFloat(String s, float n) throws SQLException {
        this.crsInternal.updateFloat(s, n);
    }
    
    @Override
    public void updateDouble(String s, double n) throws SQLException {
        this.crsInternal.updateDouble(s, n);
    }
    
    @Override
    public void updateBigDecimal(String s, BigDecimal bigDecimal) throws SQLException {
        this.crsInternal.updateBigDecimal(s, bigDecimal);
    }
    
    @Override
    public void updateString(String s, String s2) throws SQLException {
        this.crsInternal.updateString(s, s2);
    }
    
    @Override
    public void updateBytes(String s, byte[] array) throws SQLException {
        this.crsInternal.updateBytes(s, array);
    }
    
    @Override
    public void updateDate(String s, Date date) throws SQLException {
        this.crsInternal.updateDate(s, date);
    }
    
    @Override
    public void updateTime(String s, Time time) throws SQLException {
        this.crsInternal.updateTime(s, time);
    }
    
    @Override
    public void updateTimestamp(String s, Timestamp timestamp) throws SQLException {
        this.crsInternal.updateTimestamp(s, timestamp);
    }
    
    @Override
    public void updateAsciiStream(String s, InputStream inputStream, int n) throws SQLException {
        this.crsInternal.updateAsciiStream(s, inputStream, n);
    }
    
    @Override
    public void updateBinaryStream(String s, InputStream inputStream, int n) throws SQLException {
        this.crsInternal.updateBinaryStream(s, inputStream, n);
    }
    
    @Override
    public void updateCharacterStream(String s, Reader reader, int n) throws SQLException {
        this.crsInternal.updateCharacterStream(s, reader, n);
    }
    
    @Override
    public void updateObject(String s, Object o, int n) throws SQLException {
        this.crsInternal.updateObject(s, o, n);
    }
    
    @Override
    public void updateObject(String s, Object o) throws SQLException {
        this.crsInternal.updateObject(s, o);
    }
    
    @Override
    public void insertRow() throws SQLException {
        this.crsInternal.insertRow();
    }
    
    @Override
    public void updateRow() throws SQLException {
        this.crsInternal.updateRow();
    }
    
    @Override
    public void deleteRow() throws SQLException {
        this.crsInternal.deleteRow();
    }
    
    @Override
    public void refreshRow() throws SQLException {
        this.crsInternal.refreshRow();
    }
    
    @Override
    public void cancelRowUpdates() throws SQLException {
        this.crsInternal.cancelRowUpdates();
    }
    
    @Override
    public void moveToInsertRow() throws SQLException {
        this.crsInternal.moveToInsertRow();
    }
    
    @Override
    public void moveToCurrentRow() throws SQLException {
        this.crsInternal.moveToCurrentRow();
    }
    
    @Override
    public Statement getStatement() throws SQLException {
        return this.crsInternal.getStatement();
    }
    
    @Override
    public Ref getRef(int n) throws SQLException {
        return this.crsInternal.getRef(n);
    }
    
    @Override
    public Blob getBlob(int n) throws SQLException {
        return this.crsInternal.getBlob(n);
    }
    
    @Override
    public Clob getClob(int n) throws SQLException {
        return this.crsInternal.getClob(n);
    }
    
    @Override
    public Array getArray(int n) throws SQLException {
        return this.crsInternal.getArray(n);
    }
    
    @Override
    public Ref getRef(String s) throws SQLException {
        return this.crsInternal.getRef(s);
    }
    
    @Override
    public Blob getBlob(String s) throws SQLException {
        return this.crsInternal.getBlob(s);
    }
    
    @Override
    public Clob getClob(String s) throws SQLException {
        return this.crsInternal.getClob(s);
    }
    
    @Override
    public Array getArray(String s) throws SQLException {
        return this.crsInternal.getArray(s);
    }
    
    @Override
    public Date getDate(int n, Calendar calendar) throws SQLException {
        return this.crsInternal.getDate(n, calendar);
    }
    
    @Override
    public Date getDate(String s, Calendar calendar) throws SQLException {
        return this.crsInternal.getDate(s, calendar);
    }
    
    @Override
    public Time getTime(int n, Calendar calendar) throws SQLException {
        return this.crsInternal.getTime(n, calendar);
    }
    
    @Override
    public Time getTime(String s, Calendar calendar) throws SQLException {
        return this.crsInternal.getTime(s, calendar);
    }
    
    @Override
    public Timestamp getTimestamp(int n, Calendar calendar) throws SQLException {
        return this.crsInternal.getTimestamp(n, calendar);
    }
    
    @Override
    public Timestamp getTimestamp(String s, Calendar calendar) throws SQLException {
        return this.crsInternal.getTimestamp(s, calendar);
    }
    
    @Override
    public void setMetaData(RowSetMetaData metaData) throws SQLException {
        this.crsInternal.setMetaData(metaData);
    }
    
    @Override
    public ResultSet getOriginal() throws SQLException {
        return this.crsInternal.getOriginal();
    }
    
    @Override
    public ResultSet getOriginalRow() throws SQLException {
        return this.crsInternal.getOriginalRow();
    }
    
    @Override
    public void setOriginalRow() throws SQLException {
        this.crsInternal.setOriginalRow();
    }
    
    @Override
    public int[] getKeyColumns() throws SQLException {
        return this.crsInternal.getKeyColumns();
    }
    
    @Override
    public void setKeyColumns(int[] keyColumns) throws SQLException {
        this.crsInternal.setKeyColumns(keyColumns);
    }
    
    @Override
    public void updateRef(int n, Ref ref) throws SQLException {
        this.crsInternal.updateRef(n, ref);
    }
    
    @Override
    public void updateRef(String s, Ref ref) throws SQLException {
        this.crsInternal.updateRef(s, ref);
    }
    
    @Override
    public void updateClob(int n, Clob clob) throws SQLException {
        this.crsInternal.updateClob(n, clob);
    }
    
    @Override
    public void updateClob(String s, Clob clob) throws SQLException {
        this.crsInternal.updateClob(s, clob);
    }
    
    @Override
    public void updateBlob(int n, Blob blob) throws SQLException {
        this.crsInternal.updateBlob(n, blob);
    }
    
    @Override
    public void updateBlob(String s, Blob blob) throws SQLException {
        this.crsInternal.updateBlob(s, blob);
    }
    
    @Override
    public void updateArray(int n, Array array) throws SQLException {
        this.crsInternal.updateArray(n, array);
    }
    
    @Override
    public void updateArray(String s, Array array) throws SQLException {
        this.crsInternal.updateArray(s, array);
    }
    
    @Override
    public void execute() throws SQLException {
        this.crsInternal.execute();
    }
    
    @Override
    public void execute(Connection connection) throws SQLException {
        this.crsInternal.execute(connection);
    }
    
    @Override
    public URL getURL(int n) throws SQLException {
        return this.crsInternal.getURL(n);
    }
    
    @Override
    public URL getURL(String s) throws SQLException {
        return this.crsInternal.getURL(s);
    }
    
    @Override
    public void writeXml(ResultSet set, Writer writer) throws SQLException {
        (this.wrs = new WebRowSetImpl()).populate(set);
        this.wrs.writeXml(writer);
    }
    
    @Override
    public void writeXml(Writer writer) throws SQLException {
        this.createWebRowSet().writeXml(writer);
    }
    
    @Override
    public void readXml(Reader reader) throws SQLException {
        (this.wrs = new WebRowSetImpl()).readXml(reader);
        this.crsInternal = (CachedRowSetImpl)this.wrs;
    }
    
    @Override
    public void readXml(InputStream inputStream) throws SQLException, IOException {
        (this.wrs = new WebRowSetImpl()).readXml(inputStream);
        this.crsInternal = (CachedRowSetImpl)this.wrs;
    }
    
    @Override
    public void writeXml(OutputStream outputStream) throws SQLException, IOException {
        this.createWebRowSet().writeXml(outputStream);
    }
    
    @Override
    public void writeXml(ResultSet set, OutputStream outputStream) throws SQLException, IOException {
        (this.wrs = new WebRowSetImpl()).populate(set);
        this.wrs.writeXml(outputStream);
    }
    
    private WebRowSet createWebRowSet() throws SQLException {
        if (this.wrs != null) {
            return this.wrs;
        }
        this.wrs = new WebRowSetImpl();
        this.crsInternal.beforeFirst();
        this.wrs.populate(this.crsInternal);
        return this.wrs;
    }
    
    @Override
    public int getJoinType() throws SQLException {
        if (this.vecJoinType == null) {
            this.setJoinType(1);
        }
        return (int)this.vecJoinType.get(this.vecJoinType.size() - 1);
    }
    
    @Override
    public void addRowSetListener(RowSetListener listener) {
        this.crsInternal.addRowSetListener(listener);
    }
    
    @Override
    public void removeRowSetListener(RowSetListener listener) {
        this.crsInternal.removeRowSetListener(listener);
    }
    
    @Override
    public Collection<?> toCollection() throws SQLException {
        return this.crsInternal.toCollection();
    }
    
    @Override
    public Collection<?> toCollection(int n) throws SQLException {
        return this.crsInternal.toCollection(n);
    }
    
    @Override
    public Collection<?> toCollection(String s) throws SQLException {
        return this.crsInternal.toCollection(s);
    }
    
    @Override
    public CachedRowSet createCopySchema() throws SQLException {
        return this.crsInternal.createCopySchema();
    }
    
    @Override
    public void setSyncProvider(String syncProvider) throws SQLException {
        this.crsInternal.setSyncProvider(syncProvider);
    }
    
    @Override
    public void acceptChanges() throws SyncProviderException {
        this.crsInternal.acceptChanges();
    }
    
    @Override
    public SyncProvider getSyncProvider() throws SQLException {
        return this.crsInternal.getSyncProvider();
    }
    
    private void readObject(ObjectInputStream objectInputStream) throws IOException, ClassNotFoundException {
        objectInputStream.defaultReadObject();
        try {
            this.resBundle = JdbcRowSetResourceBundle.getJdbcRowSetResourceBundle();
        }
        catch (IOException cause) {
            throw new RuntimeException(cause);
        }
    }
}
